#include <windows.h>
#include "mmsystem.h"
#include <stdio.h>
#include <string.h>
typedef unsigned int uint;
typedef unsigned char uchar;

char szMessage[1024];
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
HBITMAP GetBitmap(HDC);
void hline(int, int, int, int c);
void vline(int, int, int, int c);

PBYTE pBits;
HWND hWnd_main;
int post_busy = 0;
char filename[256];
void check_filename(char *p);
void put_key_down(WPARAM wParam, LPARAM lParam);
void put_key_up(WPARAM wParam, LPARAM lParam);
int get_key(void);
void unget_key(int k);
int unget_key_data = 0;
VOID CALLBACK timeProc();
void exe_path(void);

static int dummy_var;

void dbg_disp(int i)
{
    char szMessage[1024];

    wsprintf(szMessage,"%d", i);
    MessageBox(NULL,szMessage,"fobO",MB_ICONINFORMATION | MB_OK);
}

void dbg_hex(int i)
{
    char szMessage[1024];

    wsprintf(szMessage,"%x", i);
    MessageBox(NULL,szMessage,"fobO",MB_ICONINFORMATION | MB_OK);
}

void dbg_str(char *p)
{
    MessageBox(NULL,p,"fobO",MB_ICONINFORMATION | MB_OK);
}

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPreInstance,
                     LPSTR lpCmdLine, int nCmdShow)
{
    HWND hWnd;
    MSG msg;
    WNDCLASS wc;   /* Windows ̃NXo^̂Ɏg\ */

    dummy_var = (int)hPreInstance; /* Warning炵 */
    wc.style         = CS_HREDRAW | CS_VREDRAW; /* NULL; */
    wc.lpfnWndProc   = WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
 /*:wc.hInstance     = NULL; */
    wc.hInstance     = hInstance;
    wc.hIcon         = LoadIcon(hInstance, "IDI_ICON1");
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = "NothingWClass";
    if (!RegisterClass(&wc))
      return(FALSE);

    check_filename(lpCmdLine);
    hWnd = CreateWindow("NothingWClass", "RECOP",
                        WS_OVERLAPPEDWINDOW,
                        0,0, 200,600,
                        NULL, NULL, hInstance, NULL);
    hWnd_main = hWnd;
    if (!hWnd)
      return(FALSE);

    DragAcceptFiles(hWnd, TRUE); /* hbOhbv */

    ShowWindow(hWnd, nCmdShow);
/*: UpdateWindow(hWnd); */

    while (GetMessage(&msg, NULL, 0, 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    return(msg.wParam);
}

void check_filename(char *p) /* R}hC̃t@C */
{
    char *q = filename;

    if (!p) {
        filename[0] = 0;
        return;
    }
    while (1) {
        if (*p == '"') p++;  /* t@C[̃_uR[e[V폜 */
        *q++ = *p;           /* FVtgJISlȂ */
        if (*p++ == 0) break;
    }
}

HDC disp_hDC, hDC1;
HBITMAP hBM1;
HFONT hFont;
char tvram_text[25][80]; /* pVRAM[Y][X](eLXg) */
char tvram_attr[25][80]; /* pVRAM[Y][X]() */
int cursor_x = -1, cursor_y; /* x-1ȂJ[\_łȂ */
int cursor_rev = 0;

void text_putsa( unsigned x, unsigned y, const char *str, unsigned atrb );
void text_putsa_sub( unsigned x, unsigned y, const char *str, unsigned atrb );
void blink(void);
void blink_sub( int x, int y, int rev );
void my_bitblt(void);

void set_cursor(int x, int y) /* J[\ړB_ŏ󋵂₷ */
{
    if (cursor_x != -1) {
        /* ÕJ[\ʒu̔̕]󋵂߂ */
        blink_sub( cursor_x, cursor_y, 0 ); /* ]͔]Ȃ */
    }
    cursor_x = x;
    cursor_y = y;
    if (cursor_x != -1) {
        /* ύX̃J[\ʒu̕󋵂ɉĔ] */
        blink_sub( cursor_x, cursor_y, cursor_rev );
    }
}

void blink()
{
    cursor_rev = 1 - cursor_rev;
    if (cursor_x == -1) return;
    blink_sub( cursor_x, cursor_y, cursor_rev );
    my_bitblt(); /* ??? J[\ʕ`悵y͂ ??? */
}

void blink_sub( int x, int y, int rev )
{
    int atrb;
    char p[3];

    if (tvram_attr[y][x] & 32)   /* 2oCg2oCgڂwĂ */
      x--;                       /* 1oCg炪J[\ɂȂ悤 */
    p[0] = tvram_text[y][x];
    if (tvram_attr[y][x+1] & 32)
      p[1] = tvram_text[y][x+1]; /* 2oCgȂJ[\2p */
    else
      p[1] = 0;
    p[2] = 0;
    atrb = tvram_attr[y][x];
    if (rev) atrb ^= 8;            /* ]𔽓] */
    text_putsa_sub(x, y, p, atrb);
}

void text_putsa( unsigned x, unsigned y, const char *str, unsigned atrb )
{
    int n = strlen(str);
    int i, s;
    uchar a;

    text_putsa_sub(x, y, str, atrb );
    /* pVRAMɂi[ */
    s = 0;
    for (i = 0; i < n; i++) {
        a = str[i];
        tvram_text[y][x+i] = a;
        tvram_attr[y][x+i] = atrb | s;
        if (s == 0 && (a >= 0x80 && a < 0xa0 || a >= 0xe0))
          s = 32; /* 2oCgmꂽ(tO2oCgڂɏ) */
        else
          s = 0;
    }
}

void text_putsa_sub( unsigned x, unsigned y, const char *str, unsigned atrb )
{
    int dx = x*8, dy = y*16, n = strlen(str);
    int c = 0;
    uchar a;

    if (atrb & 1) c |= 0xff0000; /*  */
    if (atrb & 2) c |= 0x0000ff; /*  */
    if (atrb & 4) c |= 0x00ff00; /*  */
    if (atrb & 8) {              /* ] */
        SetTextColor(hDC1, 0);   /*  */
        SetBkColor(hDC1, c);
    }
    else {
        SetTextColor(hDC1, c);
        SetBkColor(hDC1, 0);     /*  */
    }
    TextOut(hDC1, dx, dy, str, n);
    if (atrb & 16) {             /*  */
        hline(dx, dx+n*8-1, dy+15, (atrb & 7) + 0x8);
    }
}

/*
  BOOL BitBlt(hdcDest, nXDest, nYDest, nWidth, nHeight, hdcSrc, nXSrc,
              nYSrc, dwRop)
    HDC hdcDest;    ]̃foCX ReLXg̃nh
    int nXDest;     ]̒`̍xW
    int nYDest;     ]̒`̍yW       ... オ0
    int nWidth;     rbg}bv̕
    int nHeight;    rbg}bv̍
    HDC hdcSrc;     ]̃foCX ReLXg
    int nXSrc;      ]̃rbg}bv̍xW
    int nYSrc;      ]̃rbg}bv̍yW ... オ0
    DWORD dwRop;    ]̃X^ Iy[V

*/

HANDLE hThread;
TIMECAPS tcaps;
UINT uTimerID;
HMIDIOUT hMidiOut;
HMIDIIN hMidiIn;
int flag_drop = 0;

LRESULT CALLBACK WndProc(HWND hWnd, UINT message,
                         WPARAM wParam, LPARAM lParam)
{
    static PAINTSTRUCT ps;
    int j;

    switch(message) {
      case WM_CREATE:
        disp_hDC = GetDC(hWnd);
        hDC1 = CreateCompatibleDC(disp_hDC);
        hBM1 = GetBitmap(disp_hDC);
        SelectObject(hDC1, hBM1);

        hFont = CreateFont(
                        16, 0, 0, 0, 0, 0, 0, 0,
                        SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS,
                        CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
                        FIXED_PITCH | FF_DONTCARE, NULL
                );
        SelectObject(hDC1, hFont);

        SetWindowPos(hWnd, 0, 0,0,
                     640+GetSystemMetrics(SM_CXSIZEFRAME)*2,
                     400
                     + GetSystemMetrics(SM_CYCAPTION)
                  /* + GetSystemMetrics(SM_CYMENU) */
                     + GetSystemMetrics(SM_CYSIZEFRAME)*2,
                     SWP_NOMOVE | SWP_NOZORDER);
        {
            /* TIMECAPS\̂Ɏgŏ̕\ƍő̕\ */
            if (timeGetDevCaps(&tcaps, sizeof(TIMECAPS)) != TIMERR_NOERROR) {
                dbg_str("Multimedia timer is not available");
            }
            if (tcaps.wPeriodMin >= 10) {
                dbg_str("Min period of multimedia timer is not enough");
            }
            /* ŏ̕\Zbg(1msx) */
            timeBeginPeriod(tcaps.wPeriodMin);
            uTimerID = timeSetEvent( 1, 1, timeProc, 0, TIME_PERIODIC );
        }
        {
            DWORD WINAPI GraphThread();
            DWORD id;

            hThread = CreateThread(NULL, 0, GraphThread, 0, 0, &id);
        }
        exe_path();
        SetTimer(hWnd, 0, 422, NULL); /* J[\_ŗp */
        break;

      case WM_SIZE:
      case WM_PAINT:
        BeginPaint(hWnd, &ps);
        BitBlt(disp_hDC, 0,0, 640,400, hDC1, 0,0, SRCCOPY);
        EndPaint(hWnd, &ps);
        break;

      case WM_TIMER:
        blink(); /* J[\_ */
        break;

      case WM_COMMAND:
        break;

      case WM_KEYDOWN:
        put_key_down(wParam, lParam);
        break;

      case WM_KEYUP:
        put_key_up(wParam, lParam);
        break;

      case WM_USER+1:
        /* do some procedure */
        post_busy = 0;
        break;

      case WM_DESTROY:
        timeKillEvent( uTimerID );
        timeEndPeriod(tcaps.wPeriodMin); /*timeBeginPeriodŎw肵ln*/

        midiInStop(hMidiIn);
        midiInReset(hMidiIn);
        midiInClose(hMidiIn);
        midiOutClose(hMidiOut);

        ReleaseDC(hWnd, disp_hDC);
        DeleteDC(hDC1);
        DeleteObject(hBM1);
        DeleteObject(hFont);
        PostQuitMessage(0);
        break;

      case WM_IME_CHAR: /* 0x286 (646) */
                        /* IMEoRł̕ wParam: 0x82a0 A0x0041 */
                        /* ͂ΉiCxg񔭐j */
        wsprintf(szMessage,"tmp=%d %04x", message, wParam);
        MessageBox(NULL, szMessage, "Hello",MB_ICONINFORMATION | MB_OK);
        break;

      case WM_DROPFILES: /* t@Chbv */
        {
            HDROP hDrop = (HDROP)wParam;
            DragQueryFile(hDrop, 0, filename, 256); /* t@C擾 */
            DragFinish(hDrop); /*  */
        }
        flag_drop = 1;
        break;

      case MM_MIM_OPEN:
        break;
      case MM_MIM_CLOSE:
        break;
      case MM_MIM_DATA:
        if (lParam == 0xfe) break; /* active sensing */
        break;
      case MM_MIM_LONGDATA:
        break;
      case MM_MIM_ERROR:
      case MM_MIM_LONGERROR:
        dbg_str("Unexpected error");
        break;

      default:
        return(DefWindowProc(hWnd, message, wParam, lParam));
    }
    return(0);
}

/*----------------------------------------------------------------*/

HBITMAP GetBitmap(HDC hdc)
{
    HBITMAP     hbm;
    char        bmphead[sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * 16];
    BITMAPINFO  *bi;
    PDWORD      pColor;
    int         i;

    bi = (BITMAPINFO*)bmphead;
    ZeroMemory(&bi->bmiHeader, sizeof(BITMAPINFOHEADER));
    bi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    bi->bmiHeader.biWidth = 640;
    bi->bmiHeader.biHeight = 400;
    bi->bmiHeader.biPlanes = 1;
    bi->bmiHeader.biBitCount = 8;
    bi->bmiHeader.biCompression = BI_RGB;
    bi->bmiHeader.biSizeImage = 640*400;
    bi->bmiHeader.biXPelsPerMeter = 0;
    bi->bmiHeader.biYPelsPerMeter = 0;
    bi->bmiHeader.biClrUsed = 16;
    bi->bmiHeader.biClrImportant = 16;
    pColor = (PDWORD)&bmphead[sizeof(BITMAPINFOHEADER)];
    /*            RRGGBB                             */
    pColor[ 0] = 0x000000; /* (OtBbNp) */
    pColor[ 1] = 0xffffff; /* (OtBbNp) */
    pColor[ 2] = 0xffff00; /* ԁ(OtBbNp) */
    pColor[ 3] = 0x00ff00; /* (OtBbNp) */
    pColor[ 4] = 0xffffff; /* ΁(OtBbNp) */
    pColor[ 5] = 0xffffff; /* (OtBbNp) */
    pColor[ 6] = 0xffff00; /* (OtBbNp) */
    pColor[ 7] = 0xff00ff; /* (OtBbNp) */
    pColor[ 8] = 0x000000; /* (eLXgp) black   */
    pColor[ 9] = 0x0000ff; /* (eLXgp) blue    */
    pColor[10] = 0xff0000; /* (eLXgp) red     */
    pColor[11] = 0xff00ff; /* (eLXgp) magenta */
    pColor[12] = 0x00ff00; /* (eLXgp) green   */
    pColor[13] = 0x00ffff; /* (eLXgp) cyan    */
    pColor[14] = 0xffff00; /* (eLXgp) yellow  */
    pColor[15] = 0xffffff; /* (eLXgp) white   */
    /* hdc = GetDC(NULL); */
    hbm = CreateDIBSection(hdc, (BITMAPINFO*)bmphead,
                           DIB_RGB_COLORS, (void**)&pBits, NULL, 0);
    for (i = 0; i < 640*400; i++) pBits[i] = 0;
    return(hbm);
}

void hline(int x1, int x2, int y, int c)
{
    int i;

    for (i = x1; i <= x2; i++) pBits[640*(399-y)+i] = c;
}

void vline(int x, int y1, int y2, int c)
{
    int i;

    for (i = y1; i <= y2; i++) pBits[640*(399-i)+x] = c;
}

void midi_out(int data)    /* MIDIfoCXɃf[^o͂ */
{
    midiOutShortMsg(hMidiOut, data);
}

#define SYSEX_BUFFER_SIZE 64
MIDIHDR  midiHdr;

void midi_out_long(char *p, int n)    /* MIDIfoCXɃf[^o͂ */
{
    MSG msg;

    midiHdr.lpData = (LPBYTE)p;
    midiHdr.dwBufferLength = n;
    midiHdr.dwFlags = 0;
    midiOutPrepareHeader(hMidiOut,  &midiHdr, sizeof(MIDIHDR));
    midiOutLongMsg(hMidiOut, &midiHdr, sizeof(MIDIHDR));
    while (midiOutUnprepareHeader(hMidiOut, &midiHdr, sizeof(MIDIHDR))
           == MIDIERR_STILLPLAYING);
/*
    while (midiHdr.dwFlags == 0);
    midiOutUnprepareHeader(hMidiOut, &midiHdr, sizeof(MIDIHDR));
*/
}

VOID CALLBACK timeProc( UINT uTimerID, UINT uMsg,
                        DWORD dwUser, DWORD dwParam1, DWORD dwParam2 )
{
    extern uint delta;              /* SPʂ̎ԊԊuAľܓl */
    extern void sequence(void);
    static unsigned int seq_time;  /* tJnij*/
    static unsigned int micro_sec; /* Ԍv덷(}CNb)⏞p */
    extern char sys_mode;     /* VXe[h(0..t 1..ҏW) */

    dummy_var = uTimerID+uMsg+dwUser+dwParam1+dwParam2; /* Warning炵 */
    if (sys_mode != 0 && sys_mode != 2) { /*t[hłȂ */
        seq_time = timeGetTime(); /* t𓾂 */
        micro_sec = 0;
        return;
    }
    while (timeGetTime() > seq_time) {
        micro_sec += delta;           /* 8333; */
        seq_time += micro_sec / 1000; /* ~Sȏ𑫂 */
        micro_sec = micro_sec % 1000; /* ~S͎z덷ݐςh */
        sequence();
#if 0
        if (!post_busy) {
            post_busy = 1;
            PostMessage(hWnd_main, WM_USER+1, 0, 0);
        }
#endif
    }
}

DWORD WINAPI GraphThread(LPVOID para)
{
    extern void prog_main(void);
    int rc;

    dummy_var = (int)para; /* Warning炵 */
    midiOutOpen(&hMidiOut, MIDI_MAPPER, NULL, NULL, CALLBACK_NULL);
    midiInOpen(&hMidiIn, 0, (DWORD)hWnd_main, NULL, CALLBACK_WINDOW);
    midiInStart(hMidiIn);
    prog_main();  /* OtBbN\ƃL[͏̃C */
    PostMessage(hWnd_main, WM_DESTROY, 0, 0);
    return(0);
}

void my_sleep()
{
    Sleep(1);
}

void my_bitblt()
{
    BitBlt(disp_hDC, 0,0, 640,400, hDC1, 0,0, SRCCOPY);
}

static int key_buffer[32];
static int key_write = 0;
static int key_read = 0;
static int key_shift = 0;
static int key_ctrl = 0;

void put_key_down(WPARAM wParam, LPARAM lParam)
{
    char tenkey_shift[] = {'0', '!', '"', '#', '$', '%', '&', '\'', '(', ')'};
    int k = wParam;

    dummy_var = (int)lParam; /* Warning炵 */
    if (k == VK_SHIFT) {key_shift = 1; return;}
    if (k == VK_CONTROL) {key_ctrl = 1; return;}

    if ((key_write + 1) & 31 == key_read) return;

    if (k < 0x30) {       /* Rg[n */
        switch (k) {
          case 0x08: k = 0x08; break; /* BackSpace */
          case 0x09: k = 0x09; break; /* Tab       */
          case 0x0d: k = 0x0d; break; /* Enter     */
          case 0x1b: k = 0x1b; break; /* Esc       */
          case 0x27: k = 0x1c; break; /*         */
          case 0x25: k = 0x1d; break; /*         */
          case 0x26: k = 0x1e; break; /*         */
          case 0x28: k = 0x1f; break; /*         */
          case 0x20: k = 0x20; break; /* Space     */
          case 0x21: k = 0x19; break; /* PageUp    */
          case 0x22: k = 0x1a; break; /* PageDown  */
          case 0x23: k = 0x01; break; /* End(Help) */
          case 0x24: k = key_shift ? 0x17 : 0x0c; break; /* Home */
          case 0x2d: k = 0x12; break; /* Insert    */
          case 0x2e: k = 0x07; break; /* Delete    */
          default:   k = k;    break;
        }
    }
    else if (k < 0x3a) {  /* tL[̂OX܂ */
        if (key_shift)
          k = tenkey_shift[k - 0x30];
        else
          k = k;
    }
    else if (k < 0x41) {
        return;           /* ϊ悪Ȃ̂ŃL[͖ */
    }
    else if (k < 0x5b) {  /* At@xbgAZ */
        if (key_ctrl)
          k = k - 0x40;
        else if (key_shift)
          k = k + 0x20;
        else
          k = k;
    }
    else if (k < 0x60) {
        return;           /* ϊ悪Ȃ̂ŃL[͖ */
    }
    else if (k < 0x6a) {  /* eL[̂OX܂ */
        if (key_ctrl)
          k = tenkey_shift[k - 0x60];
        else
          k = k - 0x30;
    }
    else if (k < 0x70) {
        switch (k) {      /* eL[̂OXȊO */
          case 0x6a: k = '*'; break;
          case 0x6b: k = '+'; break;
          case 0x6c: return;
          case 0x6d: k = '-'; break;
          case 0x6e: k = '.'; break;
          case 0x6f: k = '/'; break;
        }
    }
    else if (k < 0x7c) {
        /* F1F12܂ */
        if (key_shift) k = k - 0x70 + 0xa2;
        else           k = k - 0x70 + 0x82;
    }
    else if (k < 0xba) {
        return;           /* ϊ悪Ȃ̂ŃL[͖ */
    }
    else  {
        /* tL[̃At@xbgтOXȊO */
        if (key_ctrl) {
            switch (k) {
              case 0xDB: k = 0x1b; break; /* Ctr-[ */
              case 0xDC: k = 0x1c; break; /* Ctr-\ */
              case 0xDD: k = 0x1d; break; /* Ctr-] */
              case 0xDE: k = 0x1e; break; /* Ctr-^ */
              case 0xE2: k = 0x1f; break; /* Ctr-_ */
              default: return;
            }
        }
        else {
            switch (k) {
              case 0xBA: k = key_shift ? '*' : ':' ; break;
              case 0xBB: k = key_shift ? '+' : ';' ; break;
              case 0xBC: k = key_shift ? '<' : ',' ; break;
              case 0xBD: k = key_shift ? '=' : '-' ; break;
              case 0xBE: k = key_shift ? '>' : '.' ; break;
              case 0xBF: k = key_shift ? '?' : '/' ; break;
              case 0xC0: k = key_shift ? '`' : '@' ; break;
              case 0xDB: k = key_shift ? '{' : '[' ; break;
              case 0xDC: k = key_shift ? '|' : '\\'; break;
              case 0xDD: k = key_shift ? '}' : ']' ; break;
              case 0xDE: k = key_shift ? '~' : '^' ; break;
              case 0xE2: k = key_shift ? '_' : '\\'; break;
              default: return;
            }
        }
    }

    key_buffer[key_write++] = k | (key_shift << 8);
    key_write &= 31;
}

void put_key_up(WPARAM wParam, LPARAM lParam)
{
    dummy_var = (int)lParam; /* Warning炵 */
    if (wParam == VK_SHIFT) {key_shift = 0; return;}
    if (wParam == VK_CONTROL) {key_ctrl = 0; return;}
}

int get_key(void)
{
    int a;

    if (unget_key_data) {
        a = unget_key_data;
        unget_key_data = 0;
        return(a);
    }
    if (key_read == key_write) return(0);
    a = key_buffer[key_read++];
    key_read &= 31;
    return(a);
}

void unget_key(int k)
{
    unget_key_data = k;
}

/* st@C̃pX擾 */
void exe_path()
{
    char lpstrAppName[256];
    int pt;

    GetModuleFileName(NULL, lpstrAppName, 256);
    /* dbg_str(lpstrAppName); */
    /*
    pt = strlen(lpstrAppName);
    while (lpstrAppName[pt] != '\\'){
        pt--;
        if(pt < 0)
          return(FALSE);
    }
    lpstrAppName[pt] = 0;
    */
}
